<?php
function markdown($str) {
    $str = htmlspecialchars(ltrim($str),ENT_QUOTES);
    $str = preg_replace('/\*\*(.+)\*\*/u', '<b>$1</b>', $str);
    $str = preg_replace('/\*([^\*]+)\*/u', '<i>$1</i>', $str);
    $str = preg_replace('/#### ([^\n]*)\n/', "<h4>$1</h4>\n", $str);
    $str = preg_replace('/### ([^\n]*)\n/', "<h3>$1</h3>\n", $str);
    $str = preg_replace('/## ([^\n]*)\n/', "<h2>$1</h2>\n", $str);
    $str = preg_replace('/# ([^\n]*)\n/', "<h1>$1</h1>\n", $str);
    $str = preg_replace('/\[([^\]]+)\]\(([^\)]+)\)/', '<a href=\'$2\'>$1</a>', $str);
    $str = preg_replace('/([^\n\r]{2,})(?:(\r\n){2,}|\r{2,}|\n{2,}|$)/u', "<p>$1</p>\n\n", $str);
    return $str;
}

$content = <<< EOF
# My Simple Markdown

This is a test of my simple markdown.  You can *emphasize* things with asterisks, or **really emphasize** things with two asterisks.

Paragraphs are separated by two newlines.

You can even embed [simple links](http://en.wikipedia.org/wiki/Markdown).
EOF;
if (isset($_REQUEST['content'])) {
    $content = $_REQUEST['content'];    
}

?>
<html>
    <head>
        <title>Mini-Markdown</title>
        <style>
            .display {
                width: 600px;
                border: solid;
                margin: auto;
            }
        </style>
    </head>
    <body>
        <div style="width: 700px; margin: auto;">
            <h1>Mini-markdown</h1>
            <p>This form lets you submit a mini-markdown document that will be rendered into HTML.  This is safer than
                allowing HTML markup in your web applications.  See <a href="http://en.wikipedia.org/wiki/Markdown">Wikipedia</a>
                for a complete Markdown syntax.  Note, this is merely a demonstration, and not production-ready code.  There
                are some <a href="http://michelf.com/projects/php-markdown/">complete Markdown libraries</a> that are available for PHP.</p>
            <form style="width: 600px; margin: auto;" action="minimarkdown.php" method='post'>
                <textarea style='width: 100%;' name='content' rows='12' cols='60'><?php echo $content; ?></textarea><br>
                <input type='submit' value='Submit' /><br /><br />
            </form>
        <div class='display'><?php echo markdown($content) ?></div>
        </div>
    </body>
</html>